/*
  DSstick  throttle based on Keyboard Joystick
  For the Arduino Pro Micro.
  
  Copyright(C) 2019- Desktop Station
  
  DSair2:
  https://desktopstation.net/wiki/doku.php/dsair2_ukeng
  
  DSair2 WebApp keyboard function mapping specification:
  https://desktopstation.net/wiki/doku.php/dsair2_keyboard


  fujigaya2 190827 for DCC Cheap Controller

*/

#include "Keyboard.h"

//#define BTN_STOP	7
#define BTN_DIR		A3
#define BTN_F0		6
#define BTN_F1		7
#define BTN_F2		8
#define BTN_F3		11
#define BTN_F4    12
//#define ENC_A		2
//#define ENC_B		3
#define SPEED_REF A2

#define WAIT_KEY	333
#define WAIT_KEY_SPD	200

//byte valenc;
short val;

//Task Schedule
unsigned long gPreviousL1 = 0; // 250ms interval(Packet Task)

//speed buffer
int prev_speed = 0;
//temp_text
char aText[16 + 1];

void setup()
{
	//PIN MODE
	//pinMode(BTN_STOP, INPUT);
	pinMode(BTN_DIR, INPUT);
	pinMode(BTN_F0, INPUT);
	pinMode(BTN_F1, INPUT);
	pinMode(BTN_F2, INPUT);
	pinMode(BTN_F3, INPUT);
  pinMode(BTN_F4, INPUT);
	
	//Internal PULL UP
	//digitalWrite(BTN_STOP, HIGH);
	digitalWrite(BTN_DIR, HIGH);
	digitalWrite(BTN_F0, HIGH);
	digitalWrite(BTN_F1, HIGH);
	digitalWrite(BTN_F2, HIGH);
	digitalWrite(BTN_F3, HIGH);
  digitalWrite(BTN_F4, HIGH);
	
	//Reset task
	gPreviousL1 = millis();
	

	// initialize control over the keyboard:
	Keyboard.begin();
}


void loop() 
{
	if( (millis() - gPreviousL1) >= 200)
	{
    //speed 値の確認！
    int joy_loco_speed = analogRead(SPEED_REF);
    //値が違う時だけ送信！ 電圧が振れる対策でabsを入れる
    if(abs(prev_speed - joy_loco_speed) > 5)
    {
      prev_speed = joy_loco_speed;
      sprintf(aText, "P%04d",joy_loco_speed);
      //Serial.print("Speed:");
      //Serial.println(aText);
      Keyboard.print(aText);
      gPreviousL1 = millis();
    }
	}	
	if( digitalRead(BTN_DIR) == 0 )
	{
		Keyboard.print("z");
		delay(WAIT_KEY);
	}
	
	if( digitalRead(BTN_F0) == 0 )
	{
		Keyboard.print("0");
		delay(WAIT_KEY);
	}
	if( digitalRead(BTN_F1) == 0 )
	{
		Keyboard.print("1");
		delay(WAIT_KEY);
	}
	
	if( digitalRead(BTN_F2) == 0 )
	{
		Keyboard.print("2");
		delay(WAIT_KEY);
	}
	
	if( digitalRead(BTN_F3) == 0 )
	{
		Keyboard.print("3");
		delay(WAIT_KEY);
	}

  if( digitalRead(BTN_F4) == 0 )
  {
    Keyboard.print("4");
    delay(WAIT_KEY);
  }
}
